﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ManageSubscriptionsCS.ReportService;
using System.Data.SqlClient;
using System.Web.Services.Protocols;

namespace ManageSubscriptionsCS
  

{
    
    public partial class SubscriptionList : System.Web.UI.Page
    {
        ReportingService2010  rs = new ReportingService2010();
        Schedule[] schedules; 
        protected void Page_Load(object sender, EventArgs e)
        {
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            BindRecipientDropDownList();
            BindScheduleDropDownList();
            if (! (IsPostBack)) 
            {
                BindCheckBoxList();
            }
        }
         private void BindRecipientDropDownList()
         {
            String sConnectionString = GetConnectionString();
            SqlConnection sqlCon = new SqlConnection(sConnectionString);
            sqlCon.Open();

            SqlCommand sqlComm = new SqlCommand("SELECT [EmailAddress] FROM [DimEmployee] order by [EmailAddress]", sqlCon);
            SqlDataReader ReaderObj = sqlComm.ExecuteReader();

            int j = 0;
            while (ReaderObj.Read())
            {
               
                DropDownList1.Items.Add(ReaderObj[0].ToString());
                j = j + 1;
            }
            
            ReaderObj.Close();  
            sqlCon.Close();
         }
        private String GetConnectionString()
        {
            String sConnectionString = 
                "Data Source=(local);Initial Catalog=AdventureWorksDW2012;Integrated Security=SSPI";
            return sConnectionString;
        }

        private void BindScheduleDropDownList()
        { 
            schedules = rs.ListSchedules(null); //Use site URL in SharePoint
            foreach (Schedule schedule in schedules)
            {
                DropDownList2.Items.Add(schedule.Name);
            }
   
        }

        private void BindCheckBoxList()
        {
          CatalogItem[] ci = GetCatalogItems();
          
          foreach (CatalogItem item in ci){
            if (item.TypeName == "Report")
            {
              CheckBoxList1.Items.Add(item.Name);
            }
          }
        }
        private CatalogItem[] GetCatalogItems() 
        {
          CatalogItem[] ci  = null;
          ci = rs.ListChildren("/Sales", true);
          return ci;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {         
          
          String matchData = null;
          foreach (Schedule schedule in schedules)
          {
            if (DropDownList2.SelectedValue == schedule.Name)
            {
              matchData = schedule.ScheduleID;
            }
          }

          for (int i = 0; i < CheckBoxList1.Items.Count; i++)
          {
            if (CheckBoxList1.Items[i].Selected)
            {
              String report = "/Sales/" + CheckBoxList1.Items[i].Text;
              String desc = "Send report by email to " + DropDownList1.SelectedValue.ToString();
              String eventType = "TimedSubscription";
              
              ParameterValue[] extensionParams = new ParameterValue[8];

              extensionParams[0] = new ParameterValue();
              extensionParams[0].Name = "TO";
              extensionParams[0].Value = DropDownList1.Text;
             
              extensionParams[1] = new ParameterValue();
              extensionParams[1].Name = "ReplyTo";
              extensionParams[1].Value = "ssrsadmin@adventureworks.com";
             
              extensionParams[2] = new ParameterValue();
              extensionParams[2].Name = "IncludeReport";
              extensionParams[2].Value = "True";
              
              extensionParams[3] = new ParameterValue();
              extensionParams[3].Name = "RenderFormat";
              extensionParams[3].Value = "MHTML";
              
              extensionParams[4] = new ParameterValue();
              extensionParams[4].Name = "Subject";
              extensionParams[4].Value = "@ReportName was executed at @ExecutionTime";
             
              extensionParams[5] = new ParameterValue();
              extensionParams[5].Name = "Comment";
              extensionParams[5].Value = "";
              
              extensionParams[6] = new ParameterValue();
              extensionParams[6].Name = "IncludeLink";
              extensionParams[6].Value = "True";
              
              extensionParams[7] = new ParameterValue();
              extensionParams[7].Name = "Priority";
              extensionParams[7].Value = "NORMAL";

              ExtensionSettings extSettings = new ExtensionSettings();
              extSettings.ParameterValues = extensionParams;
              extSettings.Extension = "Report Server Email";

              ItemParameter[] rParameters = rs.GetItemParameters("/Sales/" + CheckBoxList1.Items[i].Text, null, true, null, null);

              int paramN = GetParamN(rParameters);

              ParameterValue[] parameters;
            if (paramN < 0)
            {
                parameters = null;
            }
            else
            {
              parameters = new ParameterValue[paramN];
              int n; // number of values per parameter
              int param = 0; //current parameter index

              for (int k = 0; k < rParameters.Length; k++)
              {
                if (rParameters[k].DefaultValues == null)
                {
                  if (rParameters[k].MultiValue == true)
                  {
                     n = rParameters[k].ValidValues.Length;
                  }
                  else
                    {
                        n = 1;
                    }
                }
                else
                {
                  n = rParameters[k].DefaultValues.Length;
                }
                for (int m = 0; m < n; m++)
                  {
                  parameters[param] = GetParameter(k, m, rParameters);
                  param = param + 1;
                  }
              }
            }
              try
              {
                rs.CreateSubscription(report, extSettings, desc, eventType, matchData, parameters);
              }
              catch (SoapException se)
                  {
                Console.WriteLine(se.Detail.InnerXml.ToString());
              }
            }
          }

          CheckBoxList1.Items.Clear();
          Button1.Visible = false;
          Label2.Visible = false;
          Label1.Visible = true;




        }

    private int GetParamN(ItemParameter[] rParameters)
    {
          int o = 0;
          int v = 0;
          int d = 0;
          int p = 0;
          for (int i = 0; i < rParameters.Length; i++)
          {
                if (rParameters[i].DefaultValues == null)
                {
                    if (rParameters[i].MultiValue == true) 
                    {
                        v = v + rParameters[i].ValidValues.Length;
                    }
                    else
                    {
                        v = 1;
                    }
                }
                else
                {
                    d = d + rParameters[i].DefaultValues.Length;
                }
                
            }
          p = o + v + d;
          return p;
  }

    private ParameterValue GetParameter(int k, int m, ItemParameter[] rParameters) 
    {
          ParameterValue parameter = new ParameterValue();
          parameter.Name = rParameters[k].Name;
          if (rParameters[k].DefaultValues == null) 
          {
            parameter.Value = rParameters[k].ValidValues[m].ToString();
          }
          else
          {
            parameter.Value = rParameters[k].DefaultValues[m].ToString();
          }
          return parameter;
    }

        
    }
}