﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management;
using System.IO;

namespace WMIQueryCS
{
    class Program
    {
        static void Main(string[] args)
        {
            const string WmiNamespace = @"\\localhost\root\Microsoft\SqlServer\ReportServer\RS_MSSQLSERVER\v11\Admin";
            const string WmiRSClass =
              @"\\localhost\root\Microsoft\SqlServer\ReportServer\RS_MSSQLSERVER\v11\admin:MSReportServer_ConfigurationSetting";
            ManagementClass serverClass;
            ManagementScope scope;
            scope = new ManagementScope(WmiNamespace);

            // Connect to the Reporting Services namespace.
            scope.Connect();
            // Create the server class.
            serverClass = new ManagementClass(WmiRSClass);
            // Connect to the management object.
            serverClass.Get();
            if (serverClass == null)
                throw new Exception("No class found");

            // Loop through the instances of the server class.
            ManagementObjectCollection instances = serverClass.GetInstances();

            foreach (ManagementObject instance in instances)
            {
                Console.Out.WriteLine("Instance Detected");
                PropertyDataCollection instProps = instance.Properties;
                Console.WriteLine("Property Name".PadRight(35) + "Value");
                foreach (PropertyData prop in instProps)
                {
                    string name = prop.Name;
                    object val = prop.Value;
                    Console.Out.Write(name.PadRight(35));
                    if (val != null)
                        Console.Out.WriteLine(val.ToString());
                    else
                        Console.Out.WriteLine("<null>");
                }
            }
            Console.WriteLine("Press any key to continue");
            Console.ReadKey();
        }
    }
}
