﻿Imports ManageSubscriptionsVB.ReportService
Imports System.Data.SqlClient
Imports System.Web.Services.Protocols

Public Class SubscriptionList
    Inherits System.Web.UI.Page

    Dim rs As New ReportingService2010()
    Dim schedules As Schedule()


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        rs.Credentials = System.Net.CredentialCache.DefaultCredentials
        BindRecipientDropDownList()
        BindScheduleDropDownList()
        If Not (IsPostBack) Then
            BindCheckBoxList()
        End If

    End Sub

    Protected Sub BindRecipientDropDownList()
        Dim sConnectionString As String = GetConnectionString()
        Dim sqlCon As New SqlConnection
        sqlCon = New SqlClient.SqlConnection(sConnectionString)
        sqlCon.Open()

        Dim sqlComm As New SqlCommand("SELECT [EmailAddress] FROM [DimEmployee] order by [EmailAddress]", sqlCon)
        Dim ReaderObj As SqlDataReader = sqlComm.ExecuteReader()

        Dim j As Integer = 0
        While (ReaderObj.Read())
            DropDownList1.Items.Add(ReaderObj.Item(0))
            j = j + 1
        End While

        ReaderObj.Close()
        sqlCon.Close()
    End Sub
    Public Function GetConnectionString()
        Dim sConnectionString As String = "Data Source=(local);Initial Catalog=AdventureWorksDW2012;Integrated Security=SSPI"
        Return sConnectionString
    End Function
    Protected Sub BindScheduleDropDownList()
        schedules = rs.ListSchedules(Nothing) 'Use site URL in SharePoint

        For Each schedule In schedules
            DropDownList2.Items.Add(schedule.Name)
        Next

    End Sub
    Protected Sub BindCheckBoxList()

        Dim ci As CatalogItem() = GetCatalogItems()
        Dim item As CatalogItem

        For Each item In ci

            If item.TypeName = "Report" Then
                CheckBoxList1.Items.Add(item.Name)
            End If

        Next

    End Sub
    Protected Function GetCatalogItems() As CatalogItem()
        Dim ci As CatalogItem() = Nothing
        ci = rs.ListChildren("/Sales", True)
        Return ci
    End Function

    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim i As Integer
        Dim schedule As Schedule
        Dim matchData As String = Nothing

        For Each schedule In schedules
            If DropDownList2.SelectedValue = schedule.Name Then
                matchData = schedule.ScheduleID
            End If
        Next

        For i = 0 To CheckBoxList1.Items.Count - 1
            If CheckBoxList1.Items(i).Selected Then

                Dim report As String = "/Sales/" + CheckBoxList1.Items(i).Text
                Dim desc As String = "Send report by email to " + DropDownList1.SelectedValue.ToString
                Dim eventType As String = "TimedSubscription"
                Dim extensionParams(7) As ParameterValue

                extensionParams(0) = New ParameterValue()
                extensionParams(0).Name = "TO"
                extensionParams(0).Value = DropDownList1.Text

                extensionParams(1) = New ParameterValue()
                extensionParams(1).Name = "ReplyTo"
                extensionParams(1).Value = "ssrsadmin@adventureworks.com"

                extensionParams(2) = New ParameterValue()
                extensionParams(2).Name = "IncludeReport"
                extensionParams(2).Value = "True"

                extensionParams(3) = New ParameterValue()
                extensionParams(3).Name = "RenderFormat"
                extensionParams(3).Value = "MHTML"

                extensionParams(4) = New ParameterValue()
                extensionParams(4).Name = "Subject"
                extensionParams(4).Value = "@ReportName was executed at @ExecutionTime"

                extensionParams(5) = New ParameterValue()
                extensionParams(5).Name = "Comment"
                extensionParams(5).Value = ""

                extensionParams(6) = New ParameterValue()
                extensionParams(6).Name = "IncludeLink"
                extensionParams(6).Value = "True"

                extensionParams(7) = New ParameterValue()
                extensionParams(7).Name = "Priority"
                extensionParams(7).Value = "NORMAL"


                Dim extSettings As New ExtensionSettings()
                extSettings.ParameterValues = extensionParams
                extSettings.Extension = "Report Server Email"

                'Get parameters that need to be set
                Dim rParameters() As ItemParameter

                rParameters = rs.GetItemParameters("/Sales/" + CheckBoxList1.Items(i).Text, Nothing, True, Nothing, Nothing)

                Dim paramN As Integer

                paramN = GetParamN(rParameters)
                'Dim parameter As New ParameterValue()
                Dim parameters(paramN) As ParameterValue
                Dim k As Integer ' number of parameters
                Dim n As Integer ' number of values per parameter
                Dim m As Integer ' counter for loop through values
                Dim param As Integer = 0 'current parameter index

                For k = 0 To rParameters.Length - 1
                    If rParameters(k).DefaultValues Is Nothing Then

                        If rParameters(k).MultiValue = True Then
                            n = rParameters(k).ValidValues.Length
                        Else
                            n = 1
                        End If

                    Else
                        n = rParameters(k).DefaultValues.Length
                    End If

                    For m = 0 To n - 1
                        parameters(param) = GetParameter(k, m, rParameters)
                        param = param + 1
                    Next m

                Next k


                Try
                    rs.CreateSubscription(report, extSettings, desc, eventType, matchData, parameters)
                Catch se As SoapException
                    Console.WriteLine(se.Detail.InnerXml.ToString())
                End Try

            End If
                Next i
        CheckBoxList1.Items.Clear()
        Button1.Visible = False
        Label2.Visible = False
        Label1.Visible = True

    End Sub
    Protected Function GetParamN(ByRef rParameters() As ItemParameter)
        Dim o As Integer = 0
        Dim v As Integer = 0
        Dim d As Integer = 0
        Dim p As Integer = 0

        For i As Integer = 0 To rParameters.Length - 1
            If rParameters(i).DefaultValues Is Nothing Then
               
                    If rParameters(i).MultiValue = True Then
                        v = v + rParameters(i).ValidValues.Length
                    Else
                        v = 1
                    End If

            Else
                d = d + rParameters(i).DefaultValues.Length
            End If
        Next i

        p = o + v + d - 1

        Return p
    End Function

    Protected Function GetParameter(ByVal k As Integer, ByVal m As Integer, ByRef rParameters() As ItemParameter) As ParameterValue
    

        Dim parameter As New ParameterValue()

        parameter.Name = rParameters(k).Name
        If rParameters(k).DefaultValues Is Nothing Then

            parameter.Value = rParameters(k).ValidValues(m).ToString
        Else
            parameter.Value = rParameters(k).DefaultValues(m).ToString
        End If

        Return parameter

    End Function

End Class