﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CustomRDLAppCS.ReportExecService;
using System.Web.Services.Protocols;
using System.IO;

namespace AdventureWorks.Render
{
    class RDLRenderer
    {
         ReportExecutionService rs = new ReportExecutionService();

        public void RenderReport(String[] args, String formatType)
        {
            rs.Credentials = System.Net.CredentialCache.DefaultCredentials;
            string sName = args[4];
            string sReportPath = args[5] + "/" + sName;
            string sHistoryID = null;
            ExecutionInfo execInfo = new ExecutionInfo();
            execInfo = rs.LoadReport(sReportPath, sHistoryID);

            Byte[] byResult = null;
            string sDevInfo = "";
            string sExtension = "";
            string sEncoding = "";
            string sMimeType = "";
            Warning[] warnings = null;
            string[] streamIDs = null;

            try
            {
                byResult = rs.Render(formatType, sDevInfo, out sExtension, 
                   out sEncoding, out sMimeType, out warnings, out streamIDs);
            }
            catch (SoapException e)
            {
                Console.WriteLine(e.Detail.OuterXml);
            }

            try
            {
                String sOutputPath = args[2];
                FileStream stream = File.Create(sOutputPath + "\\" + sName + "." + sExtension, byResult.Length);
                Console.WriteLine("File created.");
                stream.Write(byResult, 0, byResult.Length);
                Console.WriteLine("Rendered results saved to file.");
                stream.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            finally
            {
                Console.WriteLine("Press ENTER to continue.");
                Console.ReadLine();
            }
        
        }
    }
}
