﻿Option Infer On
Imports System.Data.SqlClient
Imports CustomRDLAppVB.ReportService
Imports System.IO

Namespace AdventureWorks.Generator
    Public Class RDLGenerator

        Dim rs As New ReportingService2010()

        Public Sub Run(args As String())
            Dim iUserID As Integer = args(0)
            Dim iReportSetID As Integer = args(1)
            Dim sPath As String = args(2)
            Dim sParentReport As String = args(3)
            Dim sReportTitle As String = args(4)
            Dim sReport() As String
            Dim sReportStyle() As String
            Dim sReportSection() As String
            ReDim sReport(0 To 0)
            ReDim sReportStyle(0 To 0)
            ReDim sReportSection(0 To 0)
            Dim rows As Integer

            Try


                Try
                    rows = GetTOC(iUserID, iReportSetID, sReport, sReportStyle, sReportSection)
                Catch ex As Exception
                    Console.WriteLine("Error on GetTOC():" + ex.Message)
                End Try
                Try

                    BuildParentReport(iUserID, iReportSetID, sPath, sParentReport, rows, sReportTitle, sReport, sReportStyle, sReportSection)
                Catch ex As Exception
                    Console.WriteLine("Error on BuildParentReport():" + ex.Message)
                End Try
                Console.WriteLine("RDL file generated successfully.")
            Catch ex As Exception
                Console.WriteLine("Error: " + ex.Message)
            Finally

                Console.WriteLine("Press ENTER to continue.")
                Console.ReadLine()
            End Try
        End Sub


        Private Function GetTOC(ByVal iUser As Integer, ByVal iReportSet As Integer, ByRef sReport() As String, ByRef sReportStyle() As String, ByRef sReportSection() As String)
            Dim sConnectionString As String = GetConnectionString()
            Dim sqlCon As New SqlConnection

            sqlCon = New SqlClient.SqlConnection(sConnectionString)
            sqlCon.Open()

            Dim sqlComm As New SqlCommand("SELECT * FROM [ReportSet] WHERE [UserID] = " + CStr(iUser) _
                    + " and [ReportSetID] = " + CStr(iReportSet) + " ORDER BY [SortOrder]", sqlCon)
            Dim ReaderObj As SqlDataReader = sqlComm.ExecuteReader()


            Dim j As Integer = 0
            While (ReaderObj.Read())
                If j >= 1 Then
                    ReDim Preserve sReport(0 To UBound(sReport) + 1)
                    ReDim Preserve sReportStyle(0 To UBound(sReportStyle) + 1)
                    ReDim Preserve sReportSection(0 To UBound(sReportSection) + 1)
                End If
                sReport(j) = ReaderObj.Item(2)
                sReportStyle(j) = ReaderObj.Item(6)
                sReportSection(j) = ReaderObj.Item(8)
                j = j + 1

            End While

            ReaderObj.Close()
            sqlCon.Close()
            Return j - 1

        End Function

        Public Function GetConnectionString()
            Dim sConnectionString As String = "Data Source=(local);Initial Catalog=CustomReports;Integrated Security=True"
            Return sConnectionString
        End Function

        Public Sub BuildParentReport(ByVal iUser As Integer, ByVal iReportSet As Integer, ByVal sPath As String,
        ByVal sRpt As String, ByVal rows As Integer, ByVal sReportTitle As String, _
        ByRef sReport() As String, ByRef sReportStyle() As String, ByRef sReportSection() As String)
            Dim xParentRDL As XElement = XElement.Load(sPath + "\" + sRpt)
            Dim xElementParent As XElement
            Dim xCurrentRDL As XElement

            Dim i As Integer = 0
            Dim iPage As Integer = 1
            Dim iSection As Integer = 1
            Dim dns As String = "{" + xParentRDL.GetDefaultNamespace().ToString + "}"

            xParentRDL.Descendants(dns + "Rectangle").Where(Function(x) x.Attribute("Name").Value = "Rectangle2").Remove()
            xElementParent = xParentRDL.Descendants(dns + "Rectangle").Where(Function(x) x.Attribute("Name").Value = "Rectangle1").First()

            For Each rpt In sReport
                If sReportStyle(i) = "Section" Then
                    xCurrentRDL = BuildSectionRDL(dns, iSection, "ReportTitlePage", iUser, iReportSet, _
                        sReportSection(i), sReport(i), i)
                    iSection = iSection + 1
                Else
                    xCurrentRDL = BuildPageRDL(dns, iPage, sReport(i), i)
                    iPage = iPage + 1
                End If

                xElementParent.AddAfterSelf(xCurrentRDL)

                i = i + 1
            Next

            xElementParent = xParentRDL.Descendants(dns + "Textbox").Where(Function(x) x.Attribute("Name").Value = "Textbox1").First()
            xElementParent.Descendants(dns + "Value").First().ReplaceWith(New XElement(dns + "Value", sReportTitle))

            xElementParent = xParentRDL.Descendants(dns + "ReportParameter").Where(Function(x) x.Attribute("Name").Value = "UserID").First()
            xElementParent.Descendants(dns + "Value").First().ReplaceWith(New XElement(dns + "Value", iUser.ToString))

            xElementParent = xParentRDL.Descendants(dns + "ReportParameter").Where(Function(x) x.Attribute("Name").Value = "ReportSetID").First()
            xElementParent.Descendants(dns + "Value").First().ReplaceWith(New XElement(dns + "Value", iReportSet.ToString))

            xParentRDL.Descendants(dns + "Body").First().Element(dns + "Height").ReplaceWith(New XElement(dns + "Height", (5.5 + 0.25 * UBound(sReport)).ToString + "in"))

            xParentRDL.Save(sPath + "\" + sReportTitle + ".rdl")


        End Sub
        Function BuildPageRDL(ByVal dns As String, ByVal iAttrID As Integer, ByVal sReportName As String, ByVal row As Integer) As XElement
            Dim xPageRDL As XElement = New XElement(dns + "Rectangle", _
                    New XAttribute("Name", "PageRectangle" + iAttrID.ToString), _
                    New XElement(dns + "ReportItems", _
                    New XElement(dns + "Subreport", _
                      New XAttribute("Name", "PageSubreport" + iAttrID.ToString), _
                      New XElement(dns + "ReportName", sReportName), _
                      New XElement(dns + "Height", "0.25in"), _
                      New XElement(dns + "Width", "1in"), _
                      New XElement(dns + "Style", _
                       New XElement(dns + "Border", _
                        New XElement(dns + "Style", "None") _
                       ) _
                      ) _
                     ) _
                    ), _
                    New XElement(dns + "PageBreak", _
                     New XElement(dns + "BreakLocation", "Start"), _
                     New XElement(dns + "ResetPageNumber", "true") _
                     ), _
                    New XElement(dns + "PageName", _
                     "=Lookup(" + iAttrID.ToString + ",Fields!PageNumber.Value,Fields!PageLabel.Value, ""dsTOC"")" _
                    ), _
                    New XElement(dns + "KeepTogether", "true"), _
                    New XElement(dns + "Top", (5 + row * 0.25).ToString + "in"), _
                    New XElement(dns + "Height", "0.25in"), _
                    New XElement(dns + "Width", "1in"), _
                    New XElement(dns + "ZIndex", "3"), _
                    New XElement(dns + "Style", _
                     New XElement(dns + "Border", _
                      New XElement(dns + "Style", "None") _
                     ) _
                    ) _
                )
            Return xPageRDL
        End Function
        Function BuildSectionRDL(ByVal dns As String, ByVal iAttrID As Integer, ByVal sReportName As String, _
        ByVal iUser As Integer, ByVal iReportSet As Integer, ByVal sSection As String, ByVal sSectionTitle As String, _
        ByVal row As Integer) As XElement
            Dim xSectionRDL As XElement = New XElement(dns + "Rectangle", _
                    New XAttribute("Name", "SectionRectangle" + iAttrID.ToString), _
                    New XElement(dns + "ReportItems", _
                    New XElement(dns + "Subreport", _
                      New XAttribute("Name", "SectionSubreport" + iAttrID.ToString), _
                      New XElement(dns + "ReportName", sReportName), _
                      New XElement(dns + "Parameters", _
                        New XElement(dns + "Parameter", _
                            New XAttribute("Name", "UserID"), _
                            New XElement(dns + "Value", iUser.ToString)), _
                        New XElement(dns + "Parameter", _
                            New XAttribute("Name", "ReportSetID"), _
                            New XElement(dns + "Value", iReportSet.ToString)), _
                        New XElement(dns + "Parameter", _
                            New XAttribute("Name", "Section"), _
                            New XElement(dns + "Value", sSection)), _
                        New XElement(dns + "Parameter", _
                            New XAttribute("Name", "SectionName"), _
                            New XElement(dns + "Value", sSectionTitle)) _
                        ), _
                      New XElement(dns + "Height", "0.25in"), _
                      New XElement(dns + "Width", "1in"), _
                      New XElement(dns + "Style", _
                       New XElement(dns + "Border", _
                        New XElement(dns + "Style", "None") _
                       ) _
                      ) _
                     ) _
                    ), _
                    New XElement(dns + "PageBreak", _
                     New XElement(dns + "BreakLocation", "Start"), _
                     New XElement(dns + "ResetPageNumber", "true") _
                     ), _
                    New XElement(dns + "PageName", "ReportTitle"), _
                    New XElement(dns + "KeepTogether", "true"), _
                    New XElement(dns + "Top", (5 + row * 0.25).ToString + "in"), _
                    New XElement(dns + "Height", "0.25in"), _
                    New XElement(dns + "Width", "1in"), _
                    New XElement(dns + "ZIndex", "3"), _
                    New XElement(dns + "Style", _
                     New XElement(dns + "Border", _
                      New XElement(dns + "Style", "None") _
                     ) _
                    ) _
                )

            Return xSectionRDL

        End Function

        Public Sub PublishReport(args As String())
            Dim sPath As String = args(2)
            Dim sParentReport As String = args(3)
            Dim sReportTitle As String = args(4)

            rs.Credentials = System.Net.CredentialCache.DefaultCredentials

            Dim sItemType As String = "Report"
            Dim sName As String = args(4)
            Dim sParent As String = args(5)
            Dim bOverwrite As Boolean = True
            Dim byDefinition As Byte() = Nothing
            Dim properties As ReportService.Property() = Nothing
            Dim warnings As ReportService.Warning() = Nothing

            Try
                Dim stream As FileStream = File.OpenRead(sPath + "\" + sName + ".rdl")
                byDefinition = New [Byte](stream.Length - 1) {}
                stream.Read(byDefinition, 0, CInt(stream.Length))
                stream.Close()
                rs.CreateCatalogItem(sItemType, sName, sParent, bOverwrite, byDefinition, properties, warnings)
                If Not (warnings Is Nothing) Then
                    Dim warning As Warning
                    For Each warning In warnings
                        Console.WriteLine(warning.Message)
                    Next warning

                Else
                    Console.WriteLine("Report: {0} created " + _
                        "successfully with no warnings", sName)
                End If

                Dim ds(0) As DataSource
                Dim s As New DataSource
                Dim dsr As New DataSourceReference
                dsr.Reference = "/Data Sources/CustomReports"
                s.Item = dsr
                s.Name = "CustomReports"
                ds(0) = s
                Dim myItem As String = sParent + "/" + sName
                rs.SetItemDataSources(myItem, ds)
                Console.WriteLine("The shared data source reference for {0} has been updated", sName)
            Catch e As Exception
                Console.WriteLine(e.Message)
            Finally

                Console.WriteLine("Press ENTER to continue.")
                Console.ReadLine()
            End Try


        End Sub
    End Class
End Namespace

