﻿Imports CustomRDLAppVB.ReportExecService
Imports System.Web.Services.Protocols
Imports System.IO

Namespace AdventureWorks.Render

    Public Class RDLRenderer

        Dim rs As New ReportExecutionService()

        Public Sub RenderReport(args As String(), formatType As String)

            rs.Credentials = System.Net.CredentialCache.DefaultCredentials
            Dim sName As String = args(4)
            Dim sReportPath As String = args(5) + "/" + sName
            Dim sHistoryID As String = Nothing
            Dim execInfo As New ExecutionInfo
            execInfo = rs.LoadReport(sReportPath, sHistoryID)

            Dim byResult As Byte() = Nothing
            Dim sDevInfo As String = ""
            Dim sExtension As String = ""
            Dim sEncoding As String = ""
            Dim sMimeType As String = ""
            Dim warnings As Warning() = Nothing
            Dim streamIDs As String() = Nothing

            Try
                byResult = rs.Render(formatType, sDevInfo, sExtension, _
                   sEncoding, sMimeType, warnings, streamIDs)

            Catch e As SoapException
                Console.WriteLine(e.Detail.OuterXml)
            End Try

            Try
                Dim sOutputPath As String = args(2)
                Dim stream As FileStream = File.Create(sOutputPath + "\" + sName + "." + sExtension, byResult.Length)
                Console.WriteLine("File created.")
                stream.Write(byResult, 0, byResult.Length)
                Console.WriteLine("Rendered results saved to file.")
                stream.Close()
            Catch e As Exception
                Console.WriteLine(e.Message)
            Finally
                Console.WriteLine("Press ENTER to continue.")
                Console.ReadLine()
            End Try
        End Sub
    End Class
End Namespace

